hdu2489之最小生成树

来源:互联网 发布:新款java小轮车 编辑:程序博客网 时间:2024/05/16 17:45

Minimal Ratio Tree

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1733    Accepted Submission(s): 505


Problem Description
For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation.




Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a tree, which is a sub-graph of the original graph, with m nodes and whose ratio is the smallest among all the trees of m nodes in the graph.
 

Input
Input contains multiple test cases. The first line of each test case contains two integers n (2<=n<=15) and m (2<=m<=n), which stands for the number of nodes in the graph and the number of nodes in the minimal ratio tree. Two zeros end the input. The next line contains n numbers which stand for the weight of each node. The following n lines contain a diagonally symmetrical n×n connectivity matrix with each element shows the weight of the edge connecting one node with another. Of course, the diagonal will be all 0, since there is no edge connecting a node with itself.



All the weights of both nodes and edges (except for the ones on the diagonal of the matrix) are integers and in the range of [1, 100].

The figure below illustrates the first test case in sample input. Node 1 and Node 3 form the minimal ratio tree. 

 

Output
For each test case output one line contains a sequence of the m nodes which constructs the minimal ratio tree. Nodes should be arranged in ascending order. If there are several such sequences, pick the one which has the smallest node number; if there's a tie, look at the second smallest node number, etc. Please note that the nodes are numbered from 1 .
 

Sample Input
3 230 20 100 6 26 0 32 3 02 21 10 22 00 0
 

Sample Output
1 31 2
题意:输入n个点,要求选m个点满足连接m个点的m-1条边权值和sum与点的权值和ans最小,即sum/ans最小,并输出所选的m个点,如果有多种情况就选第一个点最小的,如果第一个点也相同就选第二个点最小的........


分析:因为n<=15,所以可以暴力枚举出所选的m个点,然后对这m个点进行最小生成树求得m-1条边的最小和,然后求sum/ans即可

//http://acm.hdu.edu.cn/showproblem.php?pid=2489#include<iostream>#include<cstdio>#include<cstdlib>#include<cstring>#include<string>#include<queue>#include<algorithm>#include<map>#include<iomanip>#define INF 99999999using namespace std;const int MAX=15+5;int edge[MAX][MAX],dist[MAX],node[MAX];//node记录最终选的点 int vale[MAX],temp[MAX],n,m;//temp记录选的m个点double minratio;bool mark[MAX];int Prim(int s){int sum=0;for(int i=1;i<=m;++i)mark[temp[i]]=false,dist[temp[i]]=edge[s][temp[i]];mark[s]=true;dist[s]=0;for(int i=1;i<m;++i){int point=s;for(int j=1;j<=m;++j){if(point == s && !mark[temp[j]])point=temp[j];if(!mark[temp[j]] && dist[point]>dist[temp[j]])point=temp[j];}mark[point]=true;sum+=dist[point];for(int j=1;j<=m;++j){if(!mark[temp[j]] && edge[point][temp[j]]<dist[temp[j]])dist[temp[j]]=edge[point][temp[j]];}}return sum;} void dfs(int k,int num){if(num == m){int ans=0;for(int i=1;i<=m;++i)ans+=vale[temp[i]];double sum=Prim(k)*1.0/ans;if(sum-minratio<-(1e-9)){minratio=sum;for(int i=1;i<=m;++i)node[i]=temp[i];}return;}if(n-k+num<m)return;for(int i=k+1;i<=n;++i){temp[num+1]=i;dfs(i,num+1);}}int main(){while(cin>>n>>m,n+m){minratio=INF*1.0;for(int i=1;i<=n;++i)cin>>vale[i];for(int i=1;i<=n;++i){for(int j=1;j<=n;++j){cin>>edge[i][j];}}for(int i=1;i<=n;++i){temp[1]=i;dfs(i,1);}for(int i=1;i<m;++i)cout<<node[i]<<' ';cout<<node[m]<<endl;}return 0;}



原创粉丝点击